<template>
  <div>
    <b-row id="selectBoxes">
      <b-col>
        {{ $t("projectLabel") }}
        <b-form-select
          v-model="selectedProjectId"
          :options="projectsSelectOptions"
          value-field="id"
          text-field="name"
          @change="changeProject"
          :disabled="true"
        >
          <template #first>
            <b-form-select-option value="" disabled>{{
              $t("emptyProjectSelect")
            }}</b-form-select-option>
          </template>
        </b-form-select>
      </b-col>
      <b-col>
        {{ $t("resourceLabel") }}
        <b-form-select
          v-model="selectedResourceId"
          :options="resourcesSelectOptions"
          value-field="id"
          text-field="name"
          @change="changeResource"
        >
          <template #first>
            <b-form-select-option value="" disabled>{{
              $t("emptyResourceSelect")
            }}</b-form-select-option>
          </template>
        </b-form-select>
      </b-col>
    </b-row>
    <b-row>
      <b-col>
        <coscine-form-group
          labelFor="DisplayName"
          :label="$t('displayName')"
          :isLoading="isLoading"
          type="input"
        >
          <b-form-input
            id="DisplayName"
            v-model="resource.DisplayName"
            required="required"
            :readonly="true"
          />
        </coscine-form-group>
      </b-col>
      <b-col>
        <coscine-form-group
          labelFor="PersitentId"
          :label="$t('persistentId')"
          :isLoading="isLoading"
          type="input"
        >
          <b-button-group id="copyButtonGroup">
            <b-form-input
              id="PersitentId"
              v-model="resource.PID"
              required="required"
              :readonly="true"
            />
            <b-button id="copyButton" @click="copyPID()"
              ><b-icon-clipboard
            /></b-button>
            <b-tooltip ref="tooltip" target="copyButton" triggers="focus">{{
              $t("pidToClipboard")
            }}</b-tooltip>
          </b-button-group>
        </coscine-form-group>
      </b-col>
    </b-row>
    <b-row>
      <b-col>
        <coscine-form-group
          labelFor="ResourceType"
          :label="$t('type')"
          :isLoading="isLoading"
          type="input"
        >
          <b-form-input
            id="ResourceType"
            :value="
              $t('ResourceTypes.' + resource.type.displayName + '.displayName')
            "
            required="required"
            :readonly="true"
          />
        </coscine-form-group>
      </b-col>
      <b-col>
        <coscine-form-group
          v-if="resource.resourceTypeOption.Size !== undefined"
          labelFor="Quota"
          :label="$t('quota')"
          :isLoading="isLoading"
          type="input"
        >
          <b-button-group id="quotaDisplay" class="progressContainer">
            <b-progress
              :max="resource.resourceTypeOption.Size * gigabyteFactor"
            >
              <b-progress-bar
                :value="progressbarOccupied"
                :variant="
                  progressbarOccupied /
                    (resource.resourceTypeOption.Size * gigabyteFactor) >=
                  0.8
                    ? 'danger'
                    : 'primary'
                "
              >
                <span
                  v-if="
                    progressbarOccupied /
                      (resource.resourceTypeOption.Size * gigabyteFactor) >=
                    0.5
                  "
                >
                  <strong
                    >{{ formatBytes(progressbarOccupied) }} /
                    {{
                      formatBytes(
                        resource.resourceTypeOption.Size * gigabyteFactor
                      )
                    }}</strong
                  >
                </span>
              </b-progress-bar>
              <b-progress-bar
                :value="
                  resource.resourceTypeOption.Size * gigabyteFactor -
                  progressbarOccupied
                "
                variant="light"
              >
                <span
                  v-if="
                    progressbarOccupied /
                      (resource.resourceTypeOption.Size * gigabyteFactor) <
                    0.5
                  "
                >
                  <strong id="quotaTextBlack"
                    >{{ formatBytes(progressbarOccupied) }} /
                    {{
                      formatBytes(
                        resource.resourceTypeOption.Size * gigabyteFactor
                      )
                    }}</strong
                  >
                </span>
              </b-progress-bar>
            </b-progress>
            <b-button @click="openQuotaManagement()"><b-icon-gear /></b-button>
          </b-button-group>
        </coscine-form-group>
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { CoscineFormGroup } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import { FileUtil, LinkUtil } from "@coscine/app-util";

import { BIconClipboard, BIconGear } from "bootstrap-vue";

export default Vue.extend({
  name: "Controls",
  components: {
    CoscineFormGroup,
    BIconClipboard,
    BIconGear,
  },
  data() {
    return {
      selectedProjectId: "",
      selectedResourceId: "",
      gigabyteFactor: 1024 * 1024 * 1024,
    };
  },
  props: {
    projectId: String,
    resourceId: String,
    projectsSelectOptions: {
      default: () => [],
      type: Array,
    },
    resourcesSelectOptions: Array,
    resource: Object,
    progressbarOccupied: Number,
    isLoading: {
      default: false,
      type: Boolean,
    },
  },
  watch: {
    projectId() {
      if (this.projectId !== this.selectedProjectId) {
        this.selectedProjectId = this.projectId;
      }
    },
    resourceId() {
      if (this.resourceId !== this.selectedResourceId) {
        this.selectedResourceId = this.resourceId;
      }
    },
  },
  methods: {
    changeProject() {
      this.$emit("changeProject", this.selectedProjectId);
    },
    changeResource() {
      this.$emit("changeResource", this.selectedResourceId);
    },
    copyPID() {
      navigator.clipboard.writeText(
        "http://hdl.handle.net/" + this.resource.PID
      );
    },
    openQuotaManagement() {
      var win = window.open(
        LinkUtil.getProjectLink("QuotaManagement"),
        "_blank"
      );
      if (win !== null) {
        win.focus();
      }
    },
    formatBytes(bytes: any) {
      return FileUtil.formatBytes(bytes);
    },
  },
  created() {
    this.selectedProjectId = this.projectId;
    this.selectedResourceId = this.resourceId;
  },
});
</script>

<style scoped>
#selectBoxes {
  padding-bottom: 1rem;
}
#copyButtonGroup {
  width: 100%;
}
#copyButton {
  margin: inherit;
}
#quotaDisplay {
  width: inherit;
}
#quotaDisplay .progress {
  margin: auto;
  padding-right: 2px;
  background-color: white;
  width: calc(100% - 6em);
}
#quotaDisplay .btn {
  margin: 0px;
}
#quotaTextBlack {
  color: black;
}
</style>
